{***************************************************************************}
{                            UNIDAD DE CONVERSION

                                  Copyright (c) 1998 Marco Antonio Alvarado
}
{***************************************************************************}

{$Q-}
UNIT UConvers;

INTERFACE

  FUNCTION ValorCifra (Cifra : Char) : longint;
  FUNCTION ValorPosicional (Posicion, Base : longint) : longint;
  FUNCTION ValorFrase (Frase : STRING; Base : longint) : longint;
  FUNCTION FraseValor (Valor : longint; Base : longint) : STRING;
  FUNCTION AjustaTamanoCeros (Frase : STRING; Ceros : longint) : STRING;

IMPLEMENTATION

  CONST
    MayorCifra = 15;
    Cifras : ARRAY [0..MayorCifra] OF Char = '0123456789ABCDEF';

  FUNCTION ValorCifra (Cifra : Char) : longint;

    VAR
      Indice : longint;

  BEGIN
    Cifra := UpCase (Cifra);
    Indice := MayorCifra;
    WHILE (Indice > 0) AND (Cifra <> Cifras [Indice]) DO Dec (Indice);
{Las cifras desconocidas valen 0.}
    ValorCifra := Indice;
  END;

  FUNCTION ValorPosicional (Posicion, Base : longint) : longint;

    VAR
      Valor : longint;
      Indice : longint;

  BEGIN
    Valor := 1;
    FOR Indice := 2 TO Posicion DO Valor := Valor * Base;
    ValorPosicional := Valor;
  END;

  FUNCTION ValorFrase (Frase : STRING; Base : longint) : longint;

    VAR
      Valor : longint;
      Indice : longint;

  BEGIN
    Valor := 0;
    FOR Indice := 1 TO length(frase) DO Inc (Valor, ValorCifra (Frase [Indice]) *
      ValorPosicional (length(frase) - Indice + 1, Base));
    ValorFrase := Valor;
  END;

  FUNCTION FraseValor (Valor : longint; Base : longint) : STRING;

    VAR
      Frase : STRING;

  BEGIN

    IF Valor = 0 THEN Frase := Cifras [0] ELSE
    BEGIN
      Frase := '';

      WHILE Valor > 0 DO
      BEGIN
        Frase := Cifras [Valor MOD Base] + Frase;
        Valor := Valor DIV Base;
      END;

    END;

    FraseValor := Frase;
  END;

  FUNCTION AjustaTamanoCeros (Frase : STRING; Ceros : longint) : STRING;
  BEGIN

    IF Ceros > length(frase) THEN
    BEGIN
      Dec (Ceros, length(frase));
      FOR Ceros := Ceros DOWNTO 1 DO Frase := '0' + Frase;
    END;

    AjustaTamanoCeros := Frase;
  END;

 END.
